| ghc-6.10.4: The GHC API | Contents | Index

SimplUtils

Documentation
mkLam :: [OutBndr] -> OutExpr -> SimplM OutExpr
mkCase :: OutExpr -> OutId -> [OutAlt] -> SimplM OutExpr
prepareAlts :: SimplEnv -> OutExpr -> OutId -> [InAlt] -> SimplM ([AltCon], [InAlt])
bindCaseBndr :: Id -> CoreExpr -> CoreExpr -> CoreExpr
preInlineUnconditionally :: SimplEnv -> TopLevelFlag -> InId -> InExpr -> Bool
postInlineUnconditionally :: SimplEnv -> TopLevelFlag -> InId -> OccInfo -> OutExpr -> Unfolding -> Bool
activeInline :: SimplEnv -> OutId -> Bool
activeRule :: DynFlags -> SimplEnv -> Maybe (Activation -> Bool)
inlineMode :: SimplifierMode
data SimplCont

Constructors

Stop CallCtxt |
CoerceIt OutCoercion SimplCont |
ApplyTo DupFlag InExpr SimplEnv SimplCont |
Select DupFlag InId [InAlt] SimplEnv SimplCont |
StrictBind InId [InBndr] InExpr SimplEnv SimplCont |
StrictArg OutExpr CallCtxt ArgInfo SimplCont |

Instances

Outputable SimplCont

data DupFlag

Constructors

OkToDup |
NoDup |

Instances

Outputable DupFlag

data ArgInfo

Constructors

ArgInfo |

ai_rules :: Bool |
ai_strs :: [Bool] |
ai_discs :: [Int] |

contIsDupable :: SimplCont -> Bool
contResultType :: SimplEnv -> OutType -> SimplCont -> OutType
contIsTrivial :: SimplCont -> Bool
contArgs :: SimplCont -> ([OutExpr], SimplCont)
dropArgs :: Int -> SimplCont -> SimplCont
countValArgs :: SimplCont -> Int
countArgs :: SimplCont -> Int
splitInlineCont :: SimplCont -> Maybe (SimplCont, SimplCont)
mkBoringStop :: SimplCont
mkLazyArgStop :: CallCtxt -> SimplCont
contIsRhsOrArg :: SimplCont -> Bool
interestingCallContext :: SimplCont -> CallCtxt
interestingArgContext :: Id -> SimplCont -> Bool
interestingArg :: OutExpr -> Bool
mkArgInfo :: Id -> Int -> SimplCont -> ArgInfo
abstractFloats :: [OutTyVar] -> SimplEnv -> OutExpr -> SimplM ([OutBind], OutExpr)
Produced by Haddock version 2.4.2